.TH ps2eps-mac 1 "Thu May 14 1992"
.SH NAME
ps2eps-mac \- converts arbitrary single page PostScript images to MacBinary EPS with PICT preview 
.SH SYNOPSIS
\fBps2eps-mac
[ -q | -batch ]
[ \-widen \fI<n>\fB | \-widen unset ]
[ \-debug \fI<level>\fB ]
[ \-log \fI<logfile>\fB ]
[ \-d \fI<directory>\fB | -pipe ]
\fIfile.ps\fR
.SH DESCRIPTION
\fBps2eps-mac\fR Version 1.0 takes an arbitrary PostScript file and
creates an Encapsulated PostScript file in MacBinary format.
This EPS file contains an embedded PICT resource which, when read by
certain Mac programs (for example, MSWord5 and MacDraw Pro), will 
be displayed on the Mac screen, allowing for easy annotation of the
image.  When the output is printed, however, the PICT preview bitmap
will be discarded and the actual, crisp PostScript will be sent to the
printer instead.
.LP
By default, executing the command \fIps2eps-mac file.ps\fR will produce 
a file named \fIfile.eps.bin\fR.  Transferred to a Mac via ftp (with
"MacBinary" enabled on the Mac end and "binary" enabled on the UNIX end),
the file will be re-named \fIfile.eps\fR. 
.LP
When converting to MacBinary format, the default file type and file
creator are listed as \fIEPSF\fR and \fIMSWD\fR, respectively.  This means
that double-clicking on the \fIfile.eps\fR Mac file will open
the file with MSWord5.  To change the default file type, set your
\fBEPSTYPE\fR environment variable before running \fIps2eps-mac\fR; to
change the default file creator, set \fBEPSCREATOR\fR.
.SH OPTIONS
.IP "\fb\-batch" 5
Do not prompt for approval when overwriting output or scratch files.
.IP "\fb\-q" 5
Synonym for -batch
.IP "\fB\-widen \fI<n>\fR" 5
Set the amount (in points) by which to widen the BoundingBox. If the input
file already contains a BoundingBox,
-widen is ignored and the original box is assumed to be correct.
Default:  1 point.
.IP "\fB\-widen unset" 5
Use a simpler method of calculating the BoundingBox.  This disables
several features including the ability to widen the BoundingBox, and the 
utilization of existing BoundingBox information.  This option will avoid
some kinds of errors.
.IP "\fB\-debug \fI<level>\fR" 5
Set the level of debug messages, from 0 (none) to 5 (all).  Default:  1.
.IP "\fB\-log \fI<logfile>\fR" 5
Set the name of the logfile in which to place debug messages.  Default:
messages are sent to stderr.
.IP "\fb\-pipe" 5
Send output macbinary to standard output.  If a logfile name isn't given with the \fB\-log\fR
option, errors are sent to \fIps2eps-mac.log\fR.
.IP "\fB\-d \fI<directory>\fR" 5
Set the name of the directory in which to place the output file. "\fB\-d\fR stdout" is equivalent to \fB\-pipe\fR. Default:  place output in the current directory.
.SH BUGS
At the default debug level (1) some errors which result in an EPS file with
no preview image are not reported.  Debug = 2 may be a better default.
.LP
The \fIps2eps-mac\fR script uses \fItr\fR to translate line endings.  This
is bound to mess up any binary stuff in the source PostScript, such as
included fonts.  You could try editing the script and playing around with the
translation options.  If you find a foolproof way to do the line ending
translation, please send mail to george@mech.seas.upenn.edu.
.SH AUTHOR
George Jefferson, george@mech.seas.upenn.edu

